<?php

/**
 * periodos_rango actions.
 *
 * @package    nomina
 * @subpackage periodos_rango
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class periodos_rangoActions extends sfActions {

    /**
     * Executes executeList action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------* Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");


        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by tab0.fecha_fin ';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            //PARAMETROS
            $id_periodo = $periodo = $request['id_periodo_filtro'];
            $id_periodo_ini = $request['id_periodo_ini'];
            $id_periodo_fin = $request['id_periodo_fin'];



            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);





            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 

tab0.id_periodo,
tab0.id_anhos,
tab0.id_meses,
tab0.fecha_ini,
tab0.fecha_fin,
tab0.id_tipo_periodo,
tab0.estado,
tab0.activo,
tab0.fecha_cierre,
tab0.fecha_cierre_nov,
tab0.max_ded_noley,
tab0.periodo,
tab0.no_dias_mes

from no_periodo_v tab0 
where tab0.id_tipo_periodo = 1 
    and tab0.id_periodo >= $id_periodo_ini  
        and tab0.id_periodo <= $id_periodo_fin

)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.id_periodo as id_periodo_ini,
tab0.id_periodo as id_periodo_fin,
tab0.id_periodo,
tab0.id_anhos,
tab0.id_meses,
tab0.fecha_ini,
tab0.fecha_fin,
tab0.id_tipo_periodo,
tab0.estado,
tab0.activo,
tab0.fecha_cierre,
tab0.fecha_cierre_nov,
tab0.max_ded_noley,
tab0.periodo,
tab0.no_dias_mes
                    
from no_periodo_v tab0 
where tab0.id_tipo_periodo = 1 
    and tab0.id_periodo >= $id_periodo_ini  
        and tab0.id_periodo <= $id_periodo_fin
    
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[periodos_rango] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("[periodos_rango] ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
